<template>
  <div class="w-100 h-100 d-flex flex-ai-center flex-jc-center flex-col">
    <button class="primary mv-5 mh-auto" @click="filters = true">Filters</button>
    <PopupContainer :show.sync="filters" :canClose="false">
      <div class="d-flex flex-col bg-white p-2 card">
        <Search :show.sync="filters" />
      </div>
    </PopupContainer>
    <!-- match card -->
    <template v-if="match && locationSet">
      <div class="card match-card m-2" :class="{ 'show-about': showAbout }">

        <!-- picbar -->
        <div class="picbar" :style="{
            width: `calc(100% / ${match.media.length})`,
            'margin-left': `${100/match.media.length*picIndex}%`
          }"
        >
          <span></span>
        </div>

        <!-- images -->
        <img v-for="(pic, index) of match.media" :key="pic" :src="pic"
          class="match-image" :style="{
            'margin-left': `${(index * 100) - (picIndex * 100)}%`
          }">

        <!-- left and right buttons -->
        <button class="left" @click="picIndex = Math.max(0, picIndex - 1)">
          previous
        </button>
        <button class="right"
          @click="picIndex = Math.min(match.media.length - 1, picIndex + 1)"
        >
          next
        </button>

        <!-- content -->
        <div class="content w-100 d-flex flex-col"
          @click="showAbout = true">
          <h2 class="text-left pl-4">{{ match.name.first }} {{ match.age }}
            <!-- <span class="text-muted ml-1" style="font-size: 10pt">
              <v-icon name="map-marker-alt"/>&nbsp;
              {{ (2 >= match.distance) ? 'Near you' : `${match.distance} Km` }}
            </span>
            <span class="text-muted text-right ml-3" style="font-size: 10pt">
              Fame: {{ match.fame_rating.toFixed(2) }}
            </span> -->
          </h2>
          <!-- toggleable extra -->
          <div class="extra text-left ph-4">
            <button class="close-button" @click.stop="showAbout = false">
              <v-icon name="times" class="fa-fw" style="width: 12px"/>
            </button>
            <div class="d-flex flex-col mt-0 ph-2 profile-header" style="border-bottom: 1px solid #e8e8e8">
              <span class="text-secondary">
                <v-icon name="map-marker-alt" class="fa-fw"/>
                {{ `${match.distance} Km away` }}
              </span>
              <span class="text-secondary">
                <v-icon name="regular/user" class="fa-fw"/>
                {{
                  match.sex == 'male' ? 'Man' :
                  match.sex == 'female' ? 'Woman' : 'Other'
                }}
              </span>
              <span class="text-secondary">
                <v-icon name="regular/star" class="fa-fw"/>
                {{ match.fame_rating.toFixed(2) }}
              </span>
              <br>
            </div>
            <p class="mt-2 ph-2">{{ match.bio }}</p>

            <template v-if="match.commonInterests">
              <p class="ph-2">You and {{ match.name.first }} have
                {{ match.commonInterests.length }} interests in common.
              </p>
              <ul v-if="match.commonInterests.length > 0">
                <li v-for="int of match.commonInterests" :key="int._id">
                  {{ int.name }}
                </li>
              </ul>
            </template>
          </div>
          <!-- {{ match }} -->
        </div>
      </div>

      <!-- like and dislike button -->
      <div class="actions mb-2">
        <AsyncButton v-if="!liking" class="icon-button text-muted mh-1" :fn="onDislike">
          <v-icon name="times" scale="2"/>
        </AsyncButton>
        <AsyncButton v-if="!disliking" class="icon-button primary mh-1" :fn="onLike">
          <v-icon name="heart" scale="2"/>
        </AsyncButton>
      </div>

    </template>
    <!-- loading icon -->
    <template v-else-if="fetching || !locationSet">
      <v-icon name="circle-notch" spin scale="1.5"/>
    </template>
    <!-- no match card -->
    <template v-else>
      <div class="match-card card d-flex m-2">
        <img
          src="https://images.pexels.com/photos/695799/pexels-photo-695799.jpeg"
          class="match-image no-match-image">
        <div class="content w-100 h-100 d-flex flex-ai-center flex-jc-center">
          <p class="m-auto">No matches found :(</p>
        </div>
      </div>
      <!-- if the user has dislikes show "undo dislikes" -->
      <!-- <div v-if="$store.state.user.dislikes.length > 0 || true"
        class="actions mb-2 d-flex flex-ai-center flex-jc-center">
        <button class="icon-button text-muted mh-1">
          <v-icon name="redo" scale="2" class="fa-flip-horizontal"/>
        </button>
        <span class="text-secondary">Undo dislikes</span>
      </div> -->
    </template>
  </div>
</template>

<script>
import { mapState } from 'vuex';
import axios from 'axios';
import Search from '@/components/Search.vue';
import PopupContainer from '@/components/PopupContainer.vue';

export default {
  components: {
    Search,
    PopupContainer,
  },
  data: () => ({
    match: null,

    fetching: true,
    showAbout: false,
    picIndex: 0,

    liking: false,
    disliking: false,

    acceptingRequest: false,
    _back: null,
    _request: null,

    filters: false,
  }),
  computed: {
    ...mapState(['locationSet']),
  },
  watch: {
    locationSet(to) {
      if (to) {
        this.fetchMatch();
      }
    },
    match() {
      this.picIndex = 0;
    },
  },
  methods: {
    fetchMatch() {
      this.fetching = true;
      axios.get('/api/user/match_feed')
        .then((res) => {
          this.match = res.data;
        })
        .catch((err) => err)
        .finally(() => this.fetching = false);
    },
    async onLike() {
      this.liking = true;
      if (this.acceptingRequest)
        await this.acceptRequest();
      else
        await this.doLike();
      this.liking = false;
    },
    async onDislike() {
      this.disliking = true;
      if (this.acceptingRequest)
        await this.rejectRequest();
      else
        await this.doDislike();
      this.disliking = false;
    },
    async acceptRequest() {
      try {
        let { data } =
          await axios.post(`/api/user/accept_request/${this._request._id}`);

        this.$bus.$emit('accepted-match', data.target);
        this.match = this._back;
        this.acceptingRequest = false;
      }
      catch(e) { e; }
    },
    async rejectRequest() {
      try {
        await axios.post(`/api/user/reject_request/${this._request._id}`);
        this.$bus.$emit('rejected-match', this._request.from);
        this.match = this._back;
        this.acceptingRequest = false;
      }
      catch(e) { e; }
    },
    async doLike() {
      try {
        await axios.post('/api/user/request', {
          target: this.match._id,
        });
        this.match = null;
        this.fetchMatch();
      }
      catch(err) {
        // They disliked/blocked us
        if (err.response && err.response.status === 400) {
          this.match = null;
          this.fetching();
        }
        else if (err.response) {
          this.error = err.response.data.error;
        }
      }
    },
    async doDislike() {
      try {
        await axios.post(`/api/user/dislike/${this.match._id}`);
        this.match = null;
        this.fetchMatch();
      }
      catch(err) {
        err;
      }
    },
  },
  mounted() {
    if (this.locationSet)
      this.fetchMatch();

    /**
     * Fired when the user clicks one of the match request bubbles
     */
    this.$bus.$on('accept-request', (request) => {
      this.acceptingRequest = true;
      this._back = this.match;
      this._request = request;
      this.match = request.from;
    });

    this.$bus.$on('new-request', (match) => {
      if (this.match && match.from._id == this.match._id) {
        this.match = null;
        this.fetchMatch();
      }
    });

    this.$bus.$on('set-match', (match) => {
      this.match = match;
    });
  },
};
</script>

<style scoped>
.match-card {
  border-radius: 8px;
  color: white;
  position: relative;

  width: 375px;
  max-width: calc(100% - 2em);
  height: 667px;
  max-height: calc(100vh - 99px - 2em);

  user-select: none;
}

.match-card.show-about {
  overflow-y: auto;
}

/* .match-card .about {
  margin-top: 100%;
} */

.match-image {
  object-fit: cover;

  width: 100%;
  height: 100%;

  position: absolute;
  top: 0;
  left: 0;

  transition: .5s all;
}

.no-match-image {
  width: calc(100% + 20px);
  height: calc(100% + 20px);
  margin: -10px;
  filter: blur(10px) grayscale(1);
}

.match-card:not(.show-about) .content {
  position: absolute;
  z-index: 9;
  color: white;
  bottom: 0;
  left: 0;

  cursor: pointer;
  transition: .5s all;
}

.match-card:not(.show-about) .content .extra {
  display: none;
}

.match-card.show-about {
  user-select: text;
}

.match-card.show-about .content {
  position: relative;
  top: calc(100% - 72.83px);

  background: white;
  color: var(--color-secondary);

  border-top-left-radius: 8px;
  border-top-right-radius: 8px;
}

.actions button.icon-button {
  width: calc(32px + 2em);
  height: calc(32px + 2em);
  font-size: 1em;
}

.actions button.icon-button:not(.primary) {
  border: 1px solid var(--color-muted) !important;
}

button.left,
button.right {
  position: absolute;
  height: 100%;
  width: 30%;
  min-width: 30px;

  top: 0;

  border-radius: 0;
  opacity: 0;
}

button.left  { left: 0; }
button.right { right: 0; }

.picbar {
  height: 12px;
  display: block;

  position: absolute;
  top: 0;
  left: 0;
  z-index: 15;
  transition: .5s all;

  padding: 4px 10px;
}

.picbar span {
  display: block;
  width: 100%;
  height: 4px;
  border-radius: 100px;
  background: white;
}

button.close-button {
  position: absolute;
  top: 0;
  right: 1em;
  transform: translateY(-50%);
  opacity: 0;
  transition: .5s all;

  padding: 0;
  width: 50px;
  height: 50px;

  display: inline-flex;
  align-items: center;
  justify-content: center;

  background: var(--color-pink);
  color: white;
}

.match-card.show-about button.close-button {
  transition: .5s all;
  opacity: 1;
}
</style>
